routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

//Route Categories
Route::resource('Categories', 'Categories\CategoriesController')->middleware('auth');
Route::resource('user', 'Users\UserController')->middleware('auth');
Route::resource('products', 'Products\ProductController')->middleware('auth');

Route::get('/', function () {
    return view('welcome');
});

Auth::routes();

Route::get('/home', 'HomeController@index')->name('home');

app/Models/Products/Product.php
<?php

namespace App\Models\Products;
use App\Image;
use App\Models\Categories\Categories;
use Illuminate\Database\Eloquent\Model;

class Product extends Model
{
    // se envian por medio de un array los datos que se quieren llenar
    protected $fillable=['category_id', 'description', 'price', 'user_id'];

    
    public function categoryname() // relacion 1 a 1 entre el modelo Product y el modelo Categories
    { 
        // Categories es el modelo donde esta la relacion, 'id' es el campo en Categories y 'category_id' es la relacion con products
        return $this->hasOne(Categories::class,'id','category_id');
    }


    public function image() // relacion 1 a 1 entre el modelo Product y el modelo Categories
    { 
        // Categories es el modelo donde esta la relacion, 'id' es el campo en Categories y 'category_id' es la relacion con products
        return $this->hasMany(Image::class,'product_id','id');
    }

}

app/Http/Controllers/Products/ProductController.php
<?php

namespace App\Http\Controllers\Products;

use App\Models\Products\Product;
use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use App\Models\Categories\Categories;
use Illuminate\Validation\Rule;
use Illuminate\Support\Facades\Auth;
use DB;
use Alert;

class ProductController extends Controller
{
    // middleware para que solo deje pasar a las vistas los usuarios autenticados
    // public function __construct()
    // {
    //     $this->middleware('auth');
    // }

    //Display a listing of the resource.
    public function index()
    {
        $products=Product::orderBy('id', 'DESC')->get();
        $categories=Categories::orderBy('name', 'DESC')->get();
        return view('products.index', compact('products', 'categories'));
    }

    public function indexApi(){
        $products=Product::orderBy('id', 'DESC')->get();
        // con este modelo estoy capturando los datos de las relaciones desde el modelo
        foreach ($products as $key => $value) {
            $value->categoryname;
            $value->image;
        }
        return $products;
    }


    public function create()
    {
        return view('products.create');
    }


    public function store(Request $request)
    {
        $this->validate($request, [
            'category_id'=> ['required'],
            'description'=> ['required'],
            'price'=> ['required'],
            ]);

        $datos=collect();
        $datos->put('category_id', $request->category_id);
        $datos->put('description', $request->description);
        $datos->put('price', $request->price);
        $datos->put('user_id',Auth::id());
        // insertGetId se utiliza para insertar en una table y recuperar el id para ser utilizado en otro proceso
        $id=Product::insertGetId($datos->toArray());


        //recuperar ID y almacenar imagenes en image_path
        if($request->img1) {
            $path1 = $request->file('img1')->store('img_products','public');
            DB::table('image_path')->insert([
                'product_id'=>$id,
                'path'=>$path1
            ]);
        }

        if($request->img2) {
            $path2 = $request->file('img2')->store('img_products','public');
            DB::table('image_path')->insert([
                'product_id'=>$id,
                'path'=>$path2
            ]);
        }

        if($request->img3) {
            $path3 = $request->file('img3')->store('img_products','public');
            DB::table('image_path')->insert([
                'product_id'=>$id,
                'path'=>$path3
            ]);
        }

        alert()->success('Success Message', 'Registro creado con éxito')->autoclose(3500);
        return redirect()->route('products.index');
    }

    public function show($id)
    {
        $products=Product::find($id);
        //dd($products->image);
        return view('products.show',compact('products'));
    }


    public function edit($id)
    {
        //
        $products=Product::find($id);
        return view('products.edit', compact('products'));
    }

    //Update the specified resource in storage.
    public function update(Request $request, $id)
    {
        // dd($request->all());
        $this->validate($request, [
            'category_id'=> ['required'],
            'description'=> ['required'],
            'price'=> ['required'],
            ]);
        $datos=collect();
        $datos->put('category_id', $request->category_id);
        $datos->put('description', $request->description);
        $datos->put('price', $request->price);
        $datos->put('user_id',Auth::id());
        Product::find($id)->update($datos->toArray());

       //recuperar ID y almacenar imagenes en image_path ('OJO FALTA CONTROLAR QUE BORRE LA IMAGEN EXISTENTE Y GUARDE LA NUEVA')
        if($request->img1) {
            $path1 = $request->file('img1')->store('img_products','public');
            DB::table('image_path')->insert([
                'product_id'=>$id,
                'path'=>$path1
            ]);
        }

        if($request->img2) {
            $path2 = $request->file('img2')->store('img_products','public');
            DB::table('image_path')->insert([
                'product_id'=>$id,
                'path'=>$path2
            ]);
        }

        if($request->img3) {
            $path3 = $request->file('img3')->store('img_products','public');
            DB::table('image_path')->insert([
                'product_id'=>$id,
                'path'=>$path3
            ]);
        }

        alert()->success('Success Message', 'Registro actualizado con éxito')->autoclose(3500);
        return redirect()->route('products.index');
    }


    public function destroy($id)
    {
        //
        Product::find($id)->delete();
        alert()->success('Success Message', 'Registro Eliminado Correctamente')->autoclose(3500);
        return redirect()->route('products.index');
    }
}

resources/views/products/edit.blade.php
@extends('layouts.app')
@section('content')

<div class="container">
  <div class="row justify-content-center">
    <div class="col-md-6">
      <div class="card o-hidden border-0 shadow-lg my-5">
        <div class="card-header">Actualizar Producto</div>
        <div class="card-body">
          <form method="POST" action="{{ route('products.update',$products->id) }}" role="form" enctype="multipart/form-data">
           {{ csrf_field() }}
           <input name="_method" type="hidden" value="PATCH"> 


           <div class="form-group row">
              <label class="col-md-3 col-form-label text-md-right">Categoría<span class="required" style="color:red">*</span></label>
              <div class="col-md-8">
              <input type="text" class="form-control" readonly value="{{$products->categoryname->name}}">
              <input name="category_id" type="hidden" class="form-control" readonly value="{{$products->categoryname->id}}">

              </div>
          </div>

          <div class="form-group row">
              <label for="name" class="col-md-3 col-form-label text-md-right">Descripción<span class="required" style="color:red">*</span></label>

              <div class="col-md-8">
                  <textarea name="description" class="form-control @error('description') is-invalid @enderror" placeholder="Ingrese una Descripción">{{$products->description}}</textarea>

                  @error('description')
                      <span class="invalid-feedback" role="alert">
                          <strong>{{ $message }}</strong>
                      </span>
                  @enderror
              </div>
          </div>

          <div class="form-group row">
              <label class="col-md-3 col-form-label text-md-right">Precio<span class="required" style="color:red">*</span></label>
              <div class="col-md-8">
                <div class="input-group mb-3">
                  <div class="input-group-prepend">
                    <span class="input-group-text">$</span>
                  </div>
                  <input id="price" type="text" min="0" class="form-control solo_numeros @error('#price') is-invalid @enderror" value="{{ number_format($products->price,0,',' ,'.')}}" required autocomplete="off">
                  <input name="price" id="price2" type="hidden" value="{{ $products->price}}">
                </div>
                  @error('name')
                      <span class="invalid-feedback" role="alert">
                          <strong>{{ $message }}</strong>
                      </span>
                  @enderror
              </div>
          </div>

          <div class="form-group row">
              <label class="col-md-3 col-form-label text-md-right">Imágenes<span class="required" style="color:red">*</span></label>
              <div class="col-md-8">
                  <input class="form-control" type="file" name="img1">
                  <input class="form-control" type="file" name="img2">
                  <input class="form-control" type="file" name="img3">
              </div>
          </div>

          <div class="form-group row">
              <label class="col-md-3 col-form-label text-md-right"></label>
              <div class="col-md-8">
                  <div id="carouselExampleIndicators" class="carousel slide" data-ride="carousel">

                  <ol class="carousel-indicators">
                  @foreach( $products->image as $item )
                      <li data-target="#carouselExampleIndicators" data-slide-to="{{ $loop->index }}" class="{{ $loop->first ? 'active' : '' }}"></li>
                  @endforeach
                  </ol>

                  <div class="carousel-inner" role="listbox">
                      @foreach( $products->image as $item )
                         <div class="carousel-item {{ $loop->first ? 'active' : '' }}">
                             <img class="d-block img-fluid style-carousel" src="{{ asset('storage/'.$item->path)}}" alt="{{ asset('storage/'.$item->path)}}">
                                <div class="carousel-caption d-none d-md-block">
                                </div>
                         </div>
                      @endforeach
                  </div>

                  <a class="carousel-control-prev" href="#carouselExampleIndicators" role="button" data-slide="prev">
                      <span class="carousel-control-prev-icon" aria-hidden="true"></span>
                      <span class="sr-only">Previous</span>
                  </a>
                  <a class="carousel-control-next" href="#carouselExampleIndicators" role="button" data-slide="next">
                      <span class="carousel-control-next-icon" aria-hidden="true"></span>
                      <span class="sr-only">Next</span>
                  </a>
                  </div>
              </div>
          </div>

            <div class="form-group row mb-0">
                <div class="col-md-6 offset-md-4">
                    <button type="submit" class="btn btn-primary">{{ __('Registrar') }}</button>
                    <a href="{{ route('products.index') }}" class="btn btn-danger" >Cancelar</a>
                </div>
            </div> 
          </form>
        </div>
      </div>
    </div>
  </div>
</div>

<script type="text/javascript">
  /* Funcion para solo numeros en el input de precio */
  $(".solo_numeros").keyup(function (){
          this.value = formatNumber(this.value.replace(/[^0-9]/g,''));
          price = parseInt($('#price').val().replace(/\./g,''));
          $('#price2').val(price);
      });
  
    // funcion para miles con . y decimales con ,
    function formatNumber(n){
      n = Number(n)
      return new Intl.NumberFormat().format(n);
    }
  /* Fin Funcion Solo Numero */
  </script>
  
 @endsection

resources/views/products/index.blade.php
@extends('layouts.app')

@section('content')
<!-- Begin Page Content -->
<div class="container-fluid">
  <!-- DataTales Example -->
  <div class="card shadow mb-4">
    <div class="card-header py-3">
      <h6 class="m-0 font-weight-bold text-primary">Lista de Productos</h6>
    </div>
    <div class="card-body">
      <div class="table-responsive">
      <div class="btn-group">
      <a href="{{ route('Categories.create') }}" class="btn btn-info" data-toggle="modal" data-target="#ModalCreate"><i class="fa fa fa-plus-square"></i>&nbsp;&nbsp;Añadir Producto</a>
      </div>
        <table class="table table-bordered" id="dataTable" width="100%" cellspacing="0">
          <thead class="thead-light">
            <tr>
              <th>Categoría</th>
              <th>Descripción</th>
              <th>Precio</th>
              <th>Ver</th>
              <th>Editar</th>
              <th>Eliminar</th>
            </tr>
          </thead>
         <!-- <tfoot>
            <tr>
              <th>Nombre</th>
              <th>Descripción</th>
              <th>Editar</th>
              <th>Eliminar</th>
            </tr>
          </tfoot> -->
          <tbody>
            @if($products->count())  
            @foreach($products as $product)  
            <tr>
              <td>{{$product->categoryname->name}}</td>
              <td>{{$product->description}}</td>
              <td>{{ '$'.number_format($product->price,0,',' ,'.')}}</td>

              <td style="width: 50px">
                <a class="btn btn-primary btn-2x" href="{{action('Products\ProductController@show', $product->id)}}">
                <i class="fa fa-eye"></i></a>
              </td>

              <td style="width: 50px">
                <a class="btn btn-primary btn-2x" href="{{action('Products\ProductController@edit', $product->id)}}">
                <i class="fa fa-pencil-square-o"></i></a>
              </td>

              <td style="width: 50px">
                <form action="{{action('Products\ProductController@destroy', $product->id)}}" method="post">
                 {{csrf_field()}}
                <input name="_method" type="hidden" value="DELETE">
                <button class="btn btn-danger btn-2x" type="submit"><i class="fa fa-bitbucket"></i></button>
                </form>
              </td>
            </tr>
             @endforeach 
             @else
             <tr>
              <td colspan="8">No hay Productos creados!</td>
            </tr>
            @endif
          </tbody>
        </table>
      </div>
    </div>
  </div>
</div>

<!--Modal Create Categories -->

  <!-- Modal -->
  <div class="modal fade" id="ModalCreate" role="dialog">
    <div class="modal-dialog modal-dialog-centered">
    
      <!-- Modal content-->
      <div class="modal-content">
        <div class="modal-header">
          <h4 class="modal-title">Crear Producto</h4>
          <button type="button" class="close" data-dismiss="modal" aria-label="Close">
          <span aria-hidden="true">&times;</span>
        </button>
        </div>
        <div class="modal-body">
          <form method="POST" action="{{ route('products.store') }}" role="form" enctype="multipart/form-data">
           {{ csrf_field() }}

            <div class="form-group row">
                <label class="col-md-3 col-form-label text-md-right">Categoría<span class="required" style="color:red">*</span></label>
                <div class="col-md-8">

                <select name="category_id" class="form-control @error('category') is-invalid @enderror" required>
                  <option value="">-Seleccione una opción-</option>
                    @foreach($categories as $category)
                    <option value="{{$category->id}}">{{$category->name}}</option>
                    @endforeach
                </select>
                    @error('name')
                        <span class="invalid-feedback" role="alert">
                            <strong>{{ $message }}</strong>
                        </span>
                    @enderror
                </div>
            </div>

             <div class="form-group row">
                <label for="name" class="col-md-3 col-form-label text-md-right">Descripción<span class="required" style="color:red">*</span></label>

                <div class="col-md-8">
                    <textarea name="description" class="form-control @error('description') is-invalid @enderror" placeholder="Ingrese una Descripción"></textarea>

                    @error('description')
                        <span class="invalid-feedback" role="alert">
                            <strong>{{ $message }}</strong>
                        </span>
                    @enderror
                </div>
            </div>
           
            <div class="form-group row">
                <label class="col-md-3 col-form-label text-md-right">Precio<span class="required" style="color:red">*</span></label>
                <div class="col-md-8">
                  <div class="input-group mb-3">
                    <div class="input-group-prepend">
                      <span class="input-group-text">$</span>
                    </div>
                    <input id="price" type="text" min="0" class="form-control solo_numeros @error('price') is-invalid @enderror" value="{{ old('price') }}" required autocomplete="off">
                    <input name="price" id="price2" type="hidden" value="">
                  </div>
                    @error('name')
                        <span class="invalid-feedback" role="alert">
                            <strong>{{ $message }}</strong>
                        </span>
                    @enderror
                </div>
            </div>

            <div class="form-group row">
                <label class="col-md-3 col-form-label text-md-right">Imágenes<span class="required" style="color:red">*</span></label>
                <div class="col-md-8">
                    <input class="form-control" type="file" name="img1">
                    <input class="form-control" type="file" name="img2">
                    <input class="form-control" type="file" name="img3">
                </div>
            </div>

            <div class="form-group row mb-0">
                <div class="col-md-6 offset-md-4">
                    <button type="submit" class="btn btn-primary">{{ __('Registrar') }}</button>
                    <button type="button" class="btn btn-danger" data-dismiss="modal">{{ __('Cerrar') }}</button>
                </div>
            </div> 
          </form>
          </div>
        </div>
     </div>
  </div>
<!--End Modal Create Categories -->

<script type="text/javascript">
  $(document).ready(function(){
     $('#dataTable').DataTable({
      "pageLength":5,
      "aLengthMenu": [[5,10,25, 50],[5,10,25, 50, "All"]],

        "language": {
            "url": "//cdn.datatables.net/plug-ins/9dcbecd42ad/i18n/Spanish.json"
        },

     }); 
  })

/* Funcion para solo numeros en el input de precio */
$(".solo_numeros").keyup(function (){
        this.value = formatNumber(this.value.replace(/[^0-9]/g,''));
        price = parseInt($('#price').val().replace(/\./g,''));
        $('#price2').val(price);
    });

  // funcion para miles con . y decimales con ,
  function formatNumber(n){
    n = Number(n)
    return new Intl.NumberFormat().format(n);
  } 

/* Fin Funcion Solo Numero */
</script>



@endsection

resources/views/products/show.blade.php
@extends('layouts.app')
@section('content')

<div class="container">
  <div class="row justify-content-center">
    <div class="col-md-6">
      <div class="card o-hidden border-0 shadow-lg my-5">
        <div class="card-header">Ver Producto</div>
        <div class="card-body">
        <form method="POST" role="form" enctype="multipart/form-data">
           {{ csrf_field() }}

            <div class="form-group row">
                <label class="col-md-3 col-form-label text-md-right">Categoría</label>
                <div class="col-md-8">
                <input type="text" class="form-control" readonly value="{{$products->categoryname->name}}">
                </div>
            </div>

             <div class="form-group row">
                <label for="name" class="col-md-3 col-form-label text-md-right">Descripción</label>

                <div class="col-md-8">
                    <textarea name="description" class="form-control" readonly>{{$products->description}}</textarea>
                </div>
            </div>
           
            <div class="form-group row">
                <label class="col-md-3 col-form-label text-md-right">Precio</label>
                <div class="col-md-8">
                  <div class="input-group mb-3">
                    <div class="input-group-prepend">
                      <span class="input-group-text">$</span>
                    </div>
                    <input id="price" type="text" class="form-control solo_numeros" value="{{ number_format($products->price,0,',' ,'.')}}" readonly>
                    <input name="price" id="price2" type="hidden" value="">
                  </div>
                </div>
            </div>

            <div class="form-group row">
                <label class="col-md-3 col-form-label text-md-right">Imágenes</label>
                <div class="col-md-8">
                    <div id="carouselExampleIndicators" class="carousel slide" data-ride="carousel">

                    <ol class="carousel-indicators">
                    @foreach( $products->image as $item )
                        <li data-target="#carouselExampleIndicators" data-slide-to="{{ $loop->index }}" class="{{ $loop->first ? 'active' : '' }}"></li>
                    @endforeach
                    </ol>

                    <div class="carousel-inner" role="listbox">
                        @foreach( $products->image as $item )
                           <div class="carousel-item {{ $loop->first ? 'active' : '' }}">
                               <img class="d-block img-fluid style-carousel" src="{{ asset('storage/'.$item->path)}}" alt="{{ asset('storage/'.$item->path)}}">
                                  <div class="carousel-caption d-none d-md-block">
                                  </div>
                           </div>
                        @endforeach
                    </div>

                    <a class="carousel-control-prev" href="#carouselExampleIndicators" role="button" data-slide="prev">
                        <span class="carousel-control-prev-icon" aria-hidden="true"></span>
                        <span class="sr-only">Previous</span>
                    </a>
                    <a class="carousel-control-next" href="#carouselExampleIndicators" role="button" data-slide="next">
                        <span class="carousel-control-next-icon" aria-hidden="true"></span>
                        <span class="sr-only">Next</span>
                    </a>
                    </div>
                </div>
            </div>

            <div class="form-group row mb-0" style="margin-left:55px;">
                <div class="col-md-6 offset-md-4">
                    {{-- <button type="submit" class="btn btn-primary">{{ __('Registrar') }}</button> --}}
                    <a href="{{ route('products.index') }}" class="btn btn-danger">Cancelar</a>
                </div>
            </div> 
          </form>
        </div>
      </div>
    </div>
  </div>
</div>
 @endsection